<?php
if ( ! defined( 'ABSPATH' ) ) {
    exit;
}
add_action( 'admin_menu', 'skycaiji_wp_admin_menu' );

function skycaiji_wp_admin_menu(){
    global $wb_settings_page_hook_theme,$submenu;
    $wb_settings_page_hook_theme = add_menu_page(
        '文章远程接口',
        '文章远程接口',
        'administrator',
        'skycaiji_wp_use',
        'skycaiji_wp_use'
    );
}

function skycaiji_wp_use(){
    require_once 'skycaiji2cms/skycaiji2cms.php';
    $scj2cms=new skycaiji2cms(
        dirname(__FILE__),
        plugins_url('skycaiji_wp'),
        'utf-8',
        true
    );
    $scj2cms->formUrl=admin_url('admin.php?page=skycaiji_wp_use');
    $scj2cms->apiUrl=admin_url('admin-ajax.php?action=skycaiji_wp_post');
    $scj2cms->funcError='scjFuncPluginError';
    $scj2cms->formHeadHtml=wp_nonce_field( 'skycaiji_wp_set', '_wpnonce_skycaiji_wp_set' );
    if($scj2cms->formIsPost()){
        //提交
        $scj2cms->funcFormPost='scjFuncFormPost';
        $scj2cms->formPost();
    }else{
        $pluginConfig=get_option('skycaiji_wp_config');
        $pluginConfig=is_array($pluginConfig)?$pluginConfig:array();
        
        $scj2cms->pluginConfig=$pluginConfig;
        $scj2cms->formRequired=array(
            'title'=>'标题',
            'content'=>'内容'
        );
        
        $scj2cms->formOptional=array(
            'excerpt'=>'文章摘要（默认空）',
            'date'=>'发布时间（默认当前时间）',
            'categories'=>'分类名称、别名或id（默认空，多个用,号分隔）',
            'tags'=>'标签（默认空，多个用,号分隔）',
            'status'=>'状态（默认publish，可填入 publish 公开、draft 草稿、private 私有）',
            'password'=>'文章密码（默认空）',
            'format'=>'文章形式（默认standard，可填入 image 图片、quote 引语、 aside 日志、standard 标准、status 状态、gallery 画廊、chat 聊天、video 视频、link 链接、audio 音频）',
            'slug'=>'URL别名（默认空）',
            'featured_media'=>'特色图片（默认空，可填入图片网址：会自动下载到媒体库；或图片id：在<a href="'.admin_url('upload.php?mode=list').'" target="_blank">媒体库列表</a>中图片链接里的post值就是图片id',
            'comment_status'=>'允许评论（默认1，可填入 1 是、0 否）',
            'ping_status'=>'允许pingback和trackback（默认1，可填入 1 是、0 否）',
            'sticky'=>'在博客中置顶（默认0，可填入 1 是、0 否）',
        );
        
        echo '<h3>文章远程发布接口</h3>';
        $scj2cms->formView();
    }
}

//报错函数
function scjFuncPluginError($error){
    global $scj2cms;
    wp_die('<h3 style="color:red;">'.$error.' <a href="'.$scj2cms->formUrl.'">返回</a></h3>');
}
//表单提交
function scjFuncFormPost($data){
    global $scj2cms;
    $error='';
    if(check_ajax_referer('skycaiji_wp_set','_wpnonce_skycaiji_wp_set',false)<=0){
        $error='表单验证失败，请刷新界面后重试';
    }
    if($error){
        scjFuncPluginError($error);
    }else{
        //保存
        update_option('skycaiji_wp_config',$data);
        wp_die('<h3 style="color:green">设置成功</h3><script type="text/javascript">window.location.href="'.$scj2cms->formUrl.'"</script>');
    }
}
?>
