<?php
/**
 * Plugin Name: 文章远程发布接口
 * Plugin URI: https://www.skycaiji.com
 * Description: wordpress文章远程免登录发布接口
 * Version: 1.1.1
 * Author: 蓝天采集
 * Author URI: https://www.skycaiji.com
 */

if ( ! defined( 'ABSPATH' ) ) {
    exit;
}

add_filter('plugin_action_links', 'skycaiji_wp_link', 10, 2 );
add_action ( "wp_ajax_nopriv_skycaiji_wp_post", 'skycaiji_wp_post_func');
function skycaiji_wp_link($links, $file) {
	static $this_plugin;
	if (!$this_plugin) $this_plugin = plugin_basename(__FILE__);

	if ($file == $this_plugin){
		$settings_link = '<a href="'.admin_url( 'admin.php?page=skycaiji_wp_use' ).'">使用</a>';
		array_unshift($links, $settings_link);
	}
	return $links;
}

//接口发布
function scjFuncApiPost(){
    $scj2cms=$GLOBALS['scj2cms'];
    if(empty($_POST['title'])){
        $scj2cms->returnJson(0,'标题为空');
    }
    if(empty($_POST['content'])){
        $scj2cms->returnJson(0,'内容为空');
    }
    
    $author=$scj2cms->randLine($scj2cms->pluginConfig['author']);
    if(is_numeric($author)){
        $author=WP_User::get_data_by('ID', $author);
    }else{
        $author=WP_User::get_data_by('login', $author);
    }
    if(!empty($author)){
        $authorId=$author->ID;
    }else{
        $authorId=0;
    }
    if($authorId<=0){
        $scj2cms->returnJson(0,'作者不存在');
    }
    $postData=is_array($_POST)?wp_unslash($_POST):array();//反转义
    //默认参数
    $defParams=array('status'=>'publish','format'=>'standard','comment_status'=>1,'ping_status'=>1);
    foreach ($defParams as $k=>$v){
        if(!isset($postData[$k])){
            $postData[$k]=$v;
        }
    }
    //转换输入的值
    if(!empty($postData['categories'])){
        $postData['categories']=explode(',',$postData['categories']);
    }
    if(!empty($postData['tags'])){
        $postData['tags']=explode(',',$postData['tags']);
    }
    if(!empty($postData['date'])){
        $postData['date']=strtotime($postData['date']);
        $postData['date']=date('Y-m-d',$postData['date']).'T'.date('H:i:s',$postData['date']);
    }
    
    $postData['comment_status']=$postData['comment_status']?'open':'closed';
    $postData['ping_status']=$postData['ping_status']?'open':'closed';
    $postData['sticky']=$postData['sticky']?true:false;
    
    set_current_user($authorId);
    //分类
    if(!empty($postData['categories'])){
        $catIds=array();
        $catNames=array();
        foreach ($postData['categories'] as $k=>$v){
            if(is_numeric($v)){
                $catIds[$v]=$v;
            }else{
                $catNames[$v]=$v;
            }
        }
        $catIds=array_values($catIds);
        $catNames=array_values($catNames);
        
        
        $cids=array();
        
        $catsDb=array();
        if(!empty($catIds)){
            $catsDb[]=get_categories(array('term_taxonomy_id'=>$catIds,'hide_empty'=>false));
        }
        if(!empty($catNames)){
            $catsDb[]=get_categories(array('name'=>$catNames,'hide_empty'=>false));
            $catsDb[]=get_categories(array('slug'=>$catNames,'hide_empty'=>false));
        }
        foreach ($catsDb as $cats){
            if(!empty($cats)){
                foreach ($cats as $cat){
                    $catId=$cat->term_id;
                    if($catId>0){
                        $cids[$catId]=$catId;
                    }
                }
            }
        }
        $postData['categories']=$cids;
    }else{
        $postData['categories']=array();
    }
    //标签
    $tags=$postData['tags'];
    $tagIds=array();
    if(!empty($tags)){
        $tagsDb=get_tags(array('name'=>$tags,'hide_empty'=>false));
        foreach ($tagsDb as $tag){
            $tagId=$tag->term_id;
            if($tagId>0){
                $tagIds[$tagId]=$tagId;
                //删除
                foreach ($tags as $k=>$v){
                    if($v==$tag->name){
                        unset($tags[$k]);
                    }
                }
            }
        }
        if(!empty($tags)){
            $request = new WP_REST_Request( 'POST', '/wp/v2/tags' );
            foreach ($tags as $tag){
                $request->set_param('name', $tag);
                $response=rest_do_request( $request );
                $respData = $response->get_data();
                if(!empty($respData)){
                    $tagId=intval($respData['id']);
                    if($tagId>0){
                        $tagIds[$tagId]=$tagId;
                    }
                }
            }
        }
    }
    $postData['tags']=$tagIds;
    
    if(!empty($postData['featured_media'])&&preg_match('/^\w+\:\/\//', $postData['featured_media'])){
        //是图片链接
        $featuredMediaUrl=$postData['featured_media'];//特色图片
        unset($postData['featured_media']);
        
        $imgCode=$scj2cms->curl($featuredMediaUrl);
        if($imgCode['success']&&$imgCode['body']){
            $imgType='';
            if(preg_match('/\bcontent-type\s*:\s*image\/(\w+)/i',$imgCode['header'],$imgType)){
                $imgType=strtolower($imgType[1]);
            }else{
                $imgType='jpg';
            }
            $imgPath=wp_get_upload_dir();
            $imgPath=$imgPath['path'];
            $imgName=md5($featuredMediaUrl).'.'.$imgType;
            $imgFile=$imgPath.'/'.$imgName;
            if(file_put_contents($imgFile, $imgCode['body'])){
                //保存成功
                $imgInfo=getimagesize($imgFile);
                if(!empty($imgInfo)){
                    $_FILES['async-upload']=array(
                        'name' => $imgName,
                        'type' => $imgInfo['mime'],
                        'tmp_name' => $imgFile,
                        'error' => 0,
                        'size' => filesize($imgFile)
                    );
                    $_POST['action']='upload-attachment';
                    $attachment_id = media_handle_upload('async-upload',0,array(),array('test_form'=>true,'action'=>$_POST['action']));
                    if(is_numeric($attachment_id)){
                        unset($imgFile);//删除临时文件
                        $postData['featured_media']=$attachment_id;
                    }
                }
            }
        }
    }
    
    if(empty($postData['featured_media'])){
        unset($postData['featured_media']);
    }
    
    //文章
    $request = new WP_REST_Request( 'POST', '/wp/v2/posts' );
    unset($postData['author']);//后台设置了作者
    $request->set_body_params($postData);
    
    $response = rest_do_request( $request );
    if ( $response->is_error() ) {
        $errors=$response->as_error()->errors;
        foreach ($errors as $k=>$v){
            $errors[$k]=implode(', ', $v);
        }
        $errors=implode(';', $errors);
        $scj2cms->returnJson(0,$errors);
    }
    
    $respData = $response->get_data();
    $id=0;
    if(!empty($respData)){
        $id=intval($respData['id']);
    }
    if($id<=0){
        $scj2cms->returnJson($id,'失败');
    }else{
        //成功
        $scj2cms->returnJson($id,'',site_url('?p='.$id));
    }
}

function skycaiji_wp_post_func(){
    require_once 'skycaiji2cms/skycaiji2cms.php';
    $GLOBALS['scj2cms']=$scj2cms=new skycaiji2cms(
        dirname(__FILE__),
        plugins_url('skycaiji_wp'),
        'utf-8',
        false
    );
    
    
    $pluginConfig=get_option('skycaiji_wp_config');
    $pluginConfig=is_array($pluginConfig)?$pluginConfig:array();
    
    $scj2cms->pluginConfig=$pluginConfig;
    $scj2cms->funcApiPost='scjFuncApiPost';
    $scj2cms->apiPost();
    wp_die();
}

if(is_admin()){
    require_once dirname( __FILE__ ) . '/admin.php';
}
